// HyperLink.cpp : implementation file
//
// HyperLink static control. Will open the default browser with the given URL
// when the user clicks on the link.
//
// Copyright (C) 1997, 1998 Chris Maunder (chrismaunder@codeguru.com)
// All rights reserved. May not be sold for profit.
//
// Thanks to Pl K. Tnder for auto-size and window caption changes.
//
// "GotoURL" function by Stuart Patterson
// As seen in the August, 1997 Windows Developer's Journal.
// Copyright 1997 by Miller Freeman, Inc. All rights reserved.
// Modified by Chris Maunder to use TCHARs instead of chars.
//
// "Default hand cursor" from Paul DiLascia's Jan 1998 MSJ article.
//

// Exemple adapte d'apres l'exe de codeguru. cet exemple n'utilise pas les MFC
// Limitations:
// - Pas de tooltips. por cette raison, le code place dans WM_MOUSEMOVE ne
// sert a rien !!!
// 
// Utilisation dans une boite de dialogue:
// ---------------------------------------
// Dans l'ex ci dessous, on a 2 controles static dans une boite de dialogue
// IDC_ABOUT_HOME_PAGE et IDC_ABOUT_SUPPORT_EMAIL
//
// BOOL WINAPI DlgProc(HWND hDlg, UINT nMsg, WPARAM wParam, LPARAM lParam )
//    {
//    static CHyperLink * p1, *p2;
//    switch (nMsg)
//	{
//    	case WM_INITDIALOG:
//	    p1 = CreateLinkCtrl( hDlg, IDC_ABOUT_HOME_PAGE );
//	    p2 = CreateLinkCtrl( hDlg, IDC_ABOUT_SUPPORT_EMAIL );
//	    return 0;
//	
//	case WM_NCDESTROY:
//	    {
//	    // Detruit les objets quand la fenetre est detruite
//	    if( p1 ) delete p1;
//	    if( p2 ) delete p2;
//	    }
//
//	case WM_CTLCOLORSTATIC:
//	    {
//	    CHyperLink * pCtrl;
//		    
//	    // Prise en compte de la couleur
//	    pCtrl = (CHyperLink *)GetWindowLong( (HWND)lParam, GWL_USERDATA );
//	    if( pCtrl )
//		return (long)pCtrl->CtlColor( (HDC)wParam, CTLCOLOR_STATIC);
//	    break;
//	    }
//
//        case WM_COMMAND:
//	    {
//	    switch (wParam)
//		case IDC_ABOUT_HOME_PAGE:
//		case IDC_ABOUT_SUPPORT_EMAIL:
//		    {
//		    HWND hwndStatic = (HWND) LOWORD(lParam); 
//		    CHyperLink * pCtrl;
//		    
//		    // Lancement du navigateur par defaut
//		    pCtrl = (CHyperLink *)GetWindowLong( hwndStatic, GWL_USERDATA );
//		    if( pCtrl )
//			pCtrl->OnClicked();
//		    break;
//		    }
//

#define STRICT
#include <windows.h>
#include "HyperLink.h"

static long FAR PASCAL LinkWinProc( HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam );



////////////////////////////////////////////////////////////////////////////////////
CHyperLink * CreateLinkCtrl( HWND hDlg, int iCtrl )
    {
    HWND hWnd;
    CHyperLink * pCtrl;
    char szUrl[1024];

    // On recupere la fenetre du controle
    hWnd = GetDlgItem( hDlg, iCtrl );

    // On cree l'objet et on l'attache  la fenetre
    pCtrl = new CHyperLink( hWnd );
    SetWindowLong( hWnd, GWL_USERDATA, (long)pCtrl );

    // On va chercher le texte du controle
    GetWindowText( hWnd, szUrl, 1024 );
    pCtrl->SetURL( szUrl );

    // We want to get mouse clicks via STN_CLICKED
    DWORD dwStyle = GetWindowLong( hWnd, GWL_STYLE);
    SetWindowLong( hWnd, GWL_STYLE, dwStyle | SS_NOTIFY);
    

    pCtrl->PositionWindow();        // Adjust size of window to fit URL if necessary
    pCtrl->SetDefaultCursor();      // Try and load up a "hand" cursor


    // On subclasse la fenetre
    pCtrl->m_LinkWindowProc = (long FAR  (PASCAL*)( HWND , UINT , WPARAM , LPARAM))GetWindowLong( hWnd, GWL_WNDPROC );
    SetWindowLong( hWnd, GWL_WNDPROC, (long)LinkWinProc );

    return pCtrl;
    }

////////////////////////////////////////////////////////////////////////////////////
long FAR PASCAL LinkWinProc( HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam )
    {
    CHyperLink * pCtrl;


    pCtrl = (CHyperLink *)GetWindowLong( hWnd, GWL_USERDATA );
    switch( Msg )
	{
//	case WM_CTLCOLORSTATIC:
//	    return (long)pCtrl->CtlColor( (HDC)wParam, CTLCOLOR_STATIC);
	case WM_MOUSEMOVE:
	    POINT pt;
	    pt.x = LOWORD(lParam);
	    pt.y = HIWORD(lParam);
	    pCtrl->OnMouseMove( wParam, pt );
	    break;
	case WM_SETCURSOR:
	    return pCtrl->OnSetCursor( (HWND) wParam, LOWORD(lParam ), HIWORD(lParam) );
	}
    if( pCtrl )
	return CallWindowProc( (WNDPROC)pCtrl->m_LinkWindowProc, hWnd, Msg, wParam, lParam );
    return 0;
    }



/////////////////////////////////////////////////////////////////////////////
// CHyperLink

CHyperLink::CHyperLink( HWND hWnd )
{
    m_hLinkCursor       = NULL;                 // No cursor as yet
    m_crLinkColour      = RGB(  0,   0, 238);   // Blue
    m_crVisitedColour   = RGB( 85,  26, 139);   // Purple
    m_crHoverColour     = ::GetSysColor(COLOR_HIGHLIGHT);
    m_bOverControl      = FALSE;                // Cursor not yet over control
    m_bVisited          = FALSE;                // Hasn't been visited yet.
    m_bUnderline        = TRUE;                 // Underline the link?
    m_bAdjustToFit      = TRUE;                 // Resize the window to fit the text?
    m_pszURL		= NULL;
    m_hWnd		= hWnd;
}

CHyperLink::~CHyperLink()
{
}


void CHyperLink::OnClicked()
{
    int result = (int)GotoURL(m_pszURL, SW_SHOW);
    m_bVisited = (result > HINSTANCE_ERROR);
    if (!m_bVisited) {
        MessageBeep(MB_ICONEXCLAMATION);     // Unable to follow link
        ReportError(result);
    } else 
        SetVisited();                        // Repaint to show visited colour
}

HBRUSH CHyperLink::CtlColor( HDC hDC, UINT nCtlColor) 
{

    if (m_bOverControl)
        SetTextColor( hDC, m_crHoverColour);
    else if (m_bVisited)
        SetTextColor( hDC, m_crVisitedColour);
    else
        SetTextColor( hDC, m_crLinkColour);

    // transparent text.
    SetBkMode( hDC, TRANSPARENT);
    return (HBRUSH)GetStockObject(NULL_BRUSH);
}

void CHyperLink::OnMouseMove(UINT nFlags, POINT & point) 
{
    if (m_bOverControl)        // Cursor is currently over control
    {
        RECT rect;
        GetClientRect( m_hWnd, &rect);

        if (! PtInRect( &rect, point))
        {
            m_bOverControl = FALSE;
            ReleaseCapture();
            //RedrawWindow();
            return;
        }
    }
    else                      // Cursor has just moved over control
    {
        m_bOverControl = TRUE;
        //RedrawWindow();
        SetCapture( m_hWnd);
    }
}

BOOL CHyperLink::OnSetCursor( HWND /*pWnd*/, UINT /*nHitTest*/, UINT /*message*/) 
{
    if (m_hLinkCursor)
    {
        ::SetCursor(m_hLinkCursor);
        return TRUE;
    }
    return FALSE;
}



/////////////////////////////////////////////////////////////////////////////
// CHyperLink operations

void CHyperLink::SetURL( char * pszURL)
{
    if( m_pszURL )
	free( m_pszURL );
    m_pszURL = strdup( pszURL );

    if ( m_hWnd != NULL ) {
        PositionWindow();
    }
}

char * CHyperLink::GetURL()
{ 
    return m_pszURL;   
}

void CHyperLink::SetColours(COLORREF crLinkColour, COLORREF crVisitedColour,
                            COLORREF crHoverColour /* = -1 */) 
{ 
    m_crLinkColour    = crLinkColour; 
    m_crVisitedColour = crVisitedColour;

	if (crHoverColour == -1)
		m_crHoverColour = ::GetSysColor(COLOR_HIGHLIGHT);
	else
		m_crHoverColour = crHoverColour;

    if ( m_hWnd != NULL )
        InvalidateRect( m_hWnd, NULL, TRUE); 
}

COLORREF CHyperLink::GetLinkColour() const
{ 
    return m_crLinkColour; 
}

COLORREF CHyperLink::GetVisitedColour() const
{
    return m_crVisitedColour; 
}

COLORREF CHyperLink::GetHoverColour() const
{
    return m_crHoverColour;
}

void CHyperLink::SetVisited(BOOL bVisited /* = TRUE */) 
{ 
    m_bVisited = bVisited; 

    if ( m_hWnd != NULL )
        InvalidateRect( m_hWnd, NULL, TRUE); 
}

BOOL CHyperLink::GetVisited() const
{ 
    return m_bVisited; 
}

void CHyperLink::SetLinkCursor(HCURSOR hCursor)
{ 
    m_hLinkCursor = hCursor;
    if (m_hLinkCursor == NULL)
        SetDefaultCursor();
}

HCURSOR CHyperLink::GetLinkCursor() const
{
    return m_hLinkCursor;
}

void CHyperLink::SetUnderline(BOOL bUnderline /* = TRUE */)
{
}

BOOL CHyperLink::GetUnderline() const
{ 
    return m_bUnderline; 
}

void CHyperLink::SetAutoSize(BOOL bAutoSize /* = TRUE */)
{
    m_bAdjustToFit = bAutoSize;

    if ( m_hWnd != NULL )
        PositionWindow();
}

BOOL CHyperLink::GetAutoSize() const
{ 
    return m_bAdjustToFit; 
}


// Move and resize the window so that the window is the same size
// as the hyperlink text. This stops the hyperlink cursor being active
// when it is not directly over the text. If the text is left justified
// then the window is merely shrunk, but if it is centred or right
// justified then the window will have to be moved as well.
//
// Suggested by Pl K. Tnder 

void CHyperLink::PositionWindow()
{
}

/////////////////////////////////////////////////////////////////////////////
// CHyperLink implementation

// The following appeared in Paul DiLascia's Jan 1998 MSJ articles.
// It loads a "hand" cursor from the winhlp32.exe module
void CHyperLink::SetDefaultCursor()
{
    if (m_hLinkCursor == NULL)                // No cursor handle - load our own
    {
        // Get the windows directory
        char strWndDir[MAX_PATH];

        GetWindowsDirectory(strWndDir, MAX_PATH);

        strcat( strWndDir, "\\winhlp32.exe");
        // This retrieves cursor #106 from winhlp32.exe, which is a hand pointer
        HMODULE hModule = LoadLibrary(strWndDir);
        if (hModule) {
            HCURSOR hHandCursor = ::LoadCursor(hModule, MAKEINTRESOURCE(106));
            if (hHandCursor)
                m_hLinkCursor = CopyCursor(hHandCursor);
        }
        FreeLibrary(hModule);
    }
}

LONG CHyperLink::GetRegKey(HKEY key, LPCTSTR subkey, LPTSTR retdata)
{
    HKEY hkey;
    LONG retval = RegOpenKeyEx(key, subkey, 0, KEY_QUERY_VALUE, &hkey);

    if (retval == ERROR_SUCCESS) {
        long datasize = MAX_PATH;
        TCHAR data[MAX_PATH];
        RegQueryValue(hkey, NULL, data, &datasize);
        lstrcpy(retdata,data);
        RegCloseKey(hkey);
    }

    return retval;
}

void CHyperLink::ReportError(int nError)
{
    char * str;
    char msg[2048];
    switch (nError) {
        case 0:                       str = "The operating system is out\nof memory or resources."; break;
        case SE_ERR_PNF:              str = "The specified path was not found."; break;
        case SE_ERR_FNF:              str = "The specified file was not found."; break;
        case ERROR_BAD_FORMAT:        str = "The .EXE file is invalid\n(non-Win32 .EXE or error in .EXE image)."; break;
        case SE_ERR_ACCESSDENIED:     str = "The operating system denied\naccess to the specified file."; break;
        case SE_ERR_ASSOCINCOMPLETE:  str = "The filename association is\nincomplete or invalid."; break;
        case SE_ERR_DDEBUSY:          str = "The DDE transaction could not\nbe completed because other DDE transactions\nwere being processed."; break;
        case SE_ERR_DDEFAIL:          str = "The DDE transaction failed."; break;
        case SE_ERR_DDETIMEOUT:       str = "The DDE transaction could not\nbe completed because the request timed out."; break;
        case SE_ERR_DLLNOTFOUND:      str = "The specified dynamic-link library was not found."; break;
        case SE_ERR_NOASSOC:          str = "There is no application associated\nwith the given filename extension."; break;
        case SE_ERR_OOM:              str = "There was not enough memory to complete the operation."; break;
        case SE_ERR_SHARE:            str = "A sharing violation occurred. ";
        default:                      str = "Unknown Error occurred."; break;
    }

    strcpy( msg, "Unable to open hyperlink:\n\n" );
    strcat( msg, str );
    MessageBox( NULL, str, "error", MB_ICONEXCLAMATION | MB_OK | MB_TASKMODAL );
}

HINSTANCE CHyperLink::GotoURL(char *  url, int showcmd)
{
    char key[MAX_PATH + MAX_PATH];

    // First try ShellExecute()
    HINSTANCE result = ShellExecute(NULL, "open", url, NULL,NULL, showcmd);

    // If it failed, get the .htm regkey and lookup the program
    if ((UINT)result <= HINSTANCE_ERROR) {

        if (GetRegKey(HKEY_CLASSES_ROOT, ".htm", key) == ERROR_SUCCESS) {
            strcat(key, "\\shell\\open\\command");

            if (GetRegKey(HKEY_CLASSES_ROOT,key,key) == ERROR_SUCCESS) {
                TCHAR *pos;
                pos = strstr(key, ("\"%1\""));
                if (pos == NULL) {                     // No quotes found
                    pos = strstr(key, ("%1"));       // Check for %1, without quotes 
                    if (pos == NULL)                   // No parameter at all...
                        pos = key+strlen(key)-1;
                    else
                        *pos = '\0';                   // Remove the parameter
                }
                else
                    *pos = '\0';                       // Remove the parameter

                strcat(pos, (" "));
                strcat(pos, url);
                result = (HINSTANCE) WinExec(key,showcmd);
            }
        }
    }

    return result;
}
