#ifndef __HYPERLINK_H__
#define __HYPERLINK_H__


class CHyperLink
{
// Construction/destruction
public:
    CHyperLink( HWND = NULL);
    ~CHyperLink();

    void SetURL( char * pszURL );
    char * GetURL();

    void SetColours(COLORREF crLinkColour, COLORREF crVisitedColour, 
                    COLORREF crHoverColour = -1);
    COLORREF GetLinkColour() const;
    COLORREF GetVisitedColour() const;
    COLORREF GetHoverColour() const;

    void SetVisited(BOOL bVisited = TRUE);
    BOOL GetVisited() const;

    void SetLinkCursor(HCURSOR hCursor);
    HCURSOR GetLinkCursor() const;

    void SetUnderline(BOOL bUnderline = TRUE);
    BOOL GetUnderline() const;

    void SetAutoSize(BOOL bAutoSize = TRUE);
    BOOL GetAutoSize() const;


    HINSTANCE GotoURL( char * pszURL, int showcmd);
    void ReportError(int nError);
    LONG GetRegKey(HKEY key, LPCTSTR subkey, LPTSTR retdata);
    void PositionWindow();
    void SetDefaultCursor();

// Protected attributes
protected:
    COLORREF m_crLinkColour, m_crVisitedColour;     // Hyperlink colours
    COLORREF m_crHoverColour;                       // Hover colour
    BOOL     m_bOverControl;                        // cursor over control?
    BOOL     m_bVisited;                            // Has it been visited?
    BOOL     m_bUnderline;                          // underline hyperlink?
    BOOL     m_bAdjustToFit;                        // Adjust window size to fit text?
    char*    m_pszURL;                              // hyperlink URL
    HCURSOR  m_hLinkCursor;                         // Cursor for hyperlink

public:
    HBRUSH CtlColor( HDC  hDC, UINT nCtlColor);
    BOOL OnSetCursor( HWND hWnd, UINT nHitTest, UINT message);
    void OnMouseMove(UINT nFlags, POINT & point);
    void OnClicked();

    HWND m_hWnd;
    long FAR ( PASCAL * m_LinkWindowProc)( HWND, UINT, WPARAM, LPARAM );
};


CHyperLink * CreateLinkCtrl( HWND hDlg, int iCtrl );
	
#endif /*__HYPERLINK_H__*/

