#include <windows.h>
#include <stdio.h>
#include "image.h"


//////////////////////////////////////////////////////////////////////
void CImage::LoadPNG( char *  fileName)
    {
// A REVOIR 

    // m_buf is the global buffer
    if (m_buf!=NULL) 
	{
  	delete [] m_buf;
	m_buf=NULL;
	}
    if( m_aColors )
	{
	delete [] m_aColors;
	m_aColors = NULL;
	}

//    m_buf = (BYTE *)::LoadPNG( fileName, &m_width, &m_height );
    m_buf = (BYTE *)::LoadPNG( fileName, &m_width, &m_height, &m_aColors, &m_Colors );

    if( m_buf == NULL )
	{
	char szMsg[1000];

	sprintf( szMsg, "Can't load '%s' !", fileName );
	MessageBox( NULL, szMsg, "Error", MB_ICONSTOP | MB_TASKMODAL );
	return;
	}
    if( m_aColors )
	{
	LoadPalette();
	return;
	}

    // do this before DWORD-alignment!!!
    // this works on packed (not DWORD-aligned) buffers
    // swap red and blue for display
//    JpegFile::BGRFromRGB(m_buf, m_width, m_height);

    // vertical flip for display
//    JpegFile::VertFlipBuf(m_buf, m_width * 3, m_height);
    }


//////////////////////////////////////////////////////////////////////
void CImage::LoadJPG( char *  fileName)
    {
    // m_buf is the global buffer
    if (m_buf!=NULL) 
	{
  	delete [] m_buf;
	m_buf=NULL;
	}

    // read to buffer tmp
    m_buf=JpegFile::JpegFileToRGB(fileName, &m_width, &m_height);

    //////////////////////
    // set up for display

    // do this before DWORD-alignment!!!
    // this works on packed (not DWORD-aligned) buffers
    // swap red and blue for display
    JpegFile::BGRFromRGB(m_buf, m_width, m_height);

    // vertical flip for display
    JpegFile::VertFlipBuf(m_buf, m_width * 3, m_height);
    }

//////////////////////////////////////////////////////////////////////
void CImage::LoadBMP(char * fileName)
    {
    if (m_buf!=NULL) 
	{
	delete [] m_buf;
	m_buf = NULL;
	}	

    BMPFile theBmpFile;

    m_buf=theBmpFile.LoadBMP(fileName, &m_width, &m_height);

    if ((m_buf==NULL) ) 
	return;

    //////////////////////
    // set up for display

    // do this before DWORD-alignment!!!
    // this works on packed (not DWORD-aligned) buffers
    // swap red and blue for display
    JpegFile::BGRFromRGB(m_buf, m_width, m_height);

    // vertical flip for display
    JpegFile::VertFlipBuf(m_buf, m_width * 3, m_height);
    }


//////////////////////////////////////////////////////////////////////
void CImage::DrawBMP( HDC hDC)
    {
    // if we don't have an image, get out of here
    if (m_buf==NULL) return;

    RECT clientRect;
    GetClientRect(m_hWnd, &clientRect);

    // Center It
    int left = max(clientRect.left, (( (clientRect.right - clientRect.left) - (int)m_width) / 2));
    int top = max(clientRect.top, (( (clientRect.bottom - clientRect.top) - (int)m_height) / 2));


    // Gestion d'une palette
    if( m_aColors )
	{
	HDC hDCMem = CreateCompatibleDC(hDC);
	HGDIOBJ hOld = SelectObject( hDCMem, m_hbitmap );

	// Le truc important ....
	SelectPalette(hDC, m_hPalette, TRUE);
	RealizePalette(hDC);
	// Fin du truc important ...

	SetStretchBltMode( hDC, COLORONCOLOR );
	StretchBlt( hDC, 0, 0, m_width, m_height, hDCMem, 0, 0, m_width, m_height, SRCCOPY );
	//BitBlt( hDC, 1, 1, m_nWidth - 2, m_nHeight - 2, hDCMem, 0, 0, SRCCOPY );
	SelectObject( hDCMem, hOld );
	ReleaseDC( m_hWnd, hDCMem );
	return;
	}


    // a 24-bit DIB is DWORD-aligned, vertically flipped and 
    // has Red and Blue bytes swapped. we already did the 
    // RGB->BGR and the flip when we read the images, now do
    // the DWORD-align

    BYTE *tmp;
    // DWORD-align for display
    tmp = JpegFile::MakeDwordAlignedBuf(m_buf, m_width, m_height, &m_widthDW );

    // set up a DIB 
    BITMAPINFOHEADER bmiHeader;
    bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
    bmiHeader.biWidth = m_width;
    bmiHeader.biHeight = m_height;
    bmiHeader.biPlanes = 1;
    bmiHeader.biBitCount = 24;
    bmiHeader.biCompression = BI_RGB;
    bmiHeader.biSizeImage = 0;
    bmiHeader.biXPelsPerMeter = 0;
    bmiHeader.biYPelsPerMeter = 0;
    bmiHeader.biClrUsed = 0;
    bmiHeader.biClrImportant = 0;


    // now blast it to the CDC passed in.
    // lines returns the number of lines actually displayed
    int lines = StretchDIBits(	hDC,
				left, top,
				bmiHeader.biWidth,
				bmiHeader.biHeight,
				0,0,
				bmiHeader.biWidth,
				bmiHeader.biHeight,
				tmp,
				(LPBITMAPINFO)&bmiHeader,
				DIB_RGB_COLORS,
				SRCCOPY);

    delete [] tmp;
    }



//////////////////////////////////////////////////////////////////////
void CImage::SaveBMP24(char * filename)
    {
    // note, because i'm lazy, most image data in this app
    // is handled as 24-bit images. this makes the DIB
    // conversion easier. 1,4,8, 15/16 and 32 bit DIBs are
    // significantly more difficult to handle.

    if (m_buf==NULL) 
	{
	MessageBox( NULL, "No Image!", "error", MB_TASKMODAL );
	return;
	}

    // image in m_buf is already BGR and vertically flipped, so we don't need
    // to do that for this function.
    // i really should make an RGB to BMP fn.

    BMPFile theBmpFile;
    theBmpFile.SaveBMP(filename, m_buf, m_width, m_height);
    }



//////////////////////////////////////////////////////////////////////
void CImage::LoadPalette()
    {
    // Pas de palette
    if( m_aColors == NULL )
	return;

    // Suppression de l'ancien bitmap
    if( m_hbitmap )
	{
	DeleteObject( (HGDIOBJ )m_hbitmap );
	DeleteObject( (HGDIOBJ )m_hPalette );
	m_hbitmap = NULL;
   	m_hPalette = NULL ;
	}
    
    // Creation d'une image avec la palette
    HDC hDC = ::GetDC(m_hWnd);
    m_hbitmap = PicturePaletteToBitmap( hDC, m_buf, m_aColors, m_Colors, m_width, m_height);    
    ReleaseDC( m_hWnd, hDC );

    // on cree la palette
    MakePalette();

    return;
    }


//////////////////////////////////////////////////////////////////////
void CImage::MakePalette()
    {
    if(m_hPalette != NULL) ::DeleteObject(m_hPalette);
    LPLOGPALETTE pLogPal = (LPLOGPALETTE) new char[2 * sizeof(WORD) +
	256 * sizeof(PALETTEENTRY)];
    pLogPal->palVersion = 0x300;
    pLogPal->palNumEntries = 256;
    for(int i = 0; i < 256; i++) 
	{
	pLogPal->palPalEntry[i].peRed = m_aColors[i].rgbRed;
	pLogPal->palPalEntry[i].peGreen = m_aColors[i].rgbGreen;
	pLogPal->palPalEntry[i].peBlue = m_aColors[i].rgbBlue;
	pLogPal->palPalEntry[i].peFlags = 0;
	}
    m_hPalette = ::CreatePalette(pLogPal);
    delete pLogPal;
    }	

//////////////////////////////////////////////////////////////////////
HBITMAP PicturePaletteToBitmap( HDC hDC, BYTE * pByte, RGBQUAD * pColors, int nColors, int cx, int cy )
    {
    void * pScan;
    BITMAPINFO * pbmInfo;
    int cxScan, i;

    // Structure de la mort
    pbmInfo = (BITMAPINFO * )malloc( sizeof(BITMAPINFOHEADER) + 256 * sizeof(RGBQUAD) );

    pbmInfo->bmiHeader.biSize = sizeof(BITMAPINFOHEADER); 
    pbmInfo->bmiHeader.biWidth = cx; 
    pbmInfo->bmiHeader.biHeight = -cy; 
    pbmInfo->bmiHeader.biPlanes = 1; 
    pbmInfo->bmiHeader.biBitCount = 8; 
    pbmInfo->bmiHeader.biCompression = BI_RGB; 
    pbmInfo->bmiHeader.biSizeImage = 0; 
    pbmInfo->bmiHeader.biXPelsPerMeter = 0; 
    pbmInfo->bmiHeader.biYPelsPerMeter = 0; 
    pbmInfo->bmiHeader.biClrUsed = 0; 
    pbmInfo->bmiHeader.biClrImportant = 0; 

    memcpy( &pbmInfo->bmiColors[0], (char *)pColors, 256 * sizeof(RGBQUAD) );


    // Chaque ligne sur une frontiere de 4 octets
    cxScan = (cx % 4) ? (cx/4 + 1)*4 : cx;
    pScan = malloc( cxScan * cy );
    memset( pScan, 0, cxScan * cy );
    HBITMAP hBitmap = CreateDIBSection( hDC,(BITMAPINFO *)pbmInfo, DIB_RGB_COLORS, &pScan, NULL, NULL );
  
    // On remplit le tableau 
    for( i = 0; i < cy; i ++)
        memcpy( (char*)pScan + cxScan*i, (char*)pByte + cx*i, cx );

    
    
    // Apres test free( pbmInfo );

    return hBitmap;
    }
