#ifndef __IMAGE_H__
#define __IMAGE_H__

#include "JpegFile.h"
#include "BMPFile.h"
#include "pngfile.h"

HBITMAP PicturePaletteToBitmap( HDC hDC, BYTE * pByte, RGBQUAD * pColors, int nColors, int cx, int cy );

//////////////////////////////////////////////////////////////////////
class CImage
{
public :
    CImage( HWND hWnd ) : m_hWnd (hWnd ) { m_buf = NULL; m_hbitmap = NULL; m_hPalette = NULL; m_aColors = NULL;}
    ~CImage() { if(m_buf) delete m_buf; if(m_aColors) delete [] m_aColors;}
    void LoadPNG(char * fileName);
    void LoadBMP(char * fileName);
    void LoadJPG(char * fileName);
    void DrawBMP( HDC hDC );
    void SaveBMP24(char * filename);

protected :    
    void MakePalette();
    void LoadPalette();
    
    BYTE * m_buf;
    UINT m_width, m_height;
    UINT m_widthDW;
    HWND m_hWnd;
    HBITMAP m_hbitmap;
    HPALETTE m_hPalette;
    RGBQUAD * m_aColors;
    int m_Colors;
};


#endif	/*__IMAGE_H__*/