/////////////////////////////////////////////////////////////////////////////
// Rev 30/12/2003                                               
// 
// 
//                           OPENWIN.CPP
//                           -----------
// 
// 
// Sylvain MARECHAL - sylvain.marechal1@libertysurf.fr
/////////////////////////////////////////////////////////////////////////////
// 
//  Utilisation :
//  -En mode creation, lancer openwin avec un argument afin de faire 
//  apparaitre la popup qui permet d'ajouter des images a l'exe
//  -En mode "blague", lancer l'exe sans argument
//
//  Les images sont ajoutes au bout de l'exe. 
//
//  A l'heure actuelle, le module png ne fonctionne pas
// 
/////////////////////////////////////////////////////////////////////////////
#include <windows.h>
#include <memory.h>
#include <stdio.h>
#include <string.h>

#include <stdlib.h>
#include <time.h>
#include <memory.h>

#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/locking.h>
#include <share.h>
#include <io.h>

#include "hyperlink.h"

#include <commctrl.h>
#include "image.h"
#include "resource.h"
#include "endexe.h"


// Protos
long FAR PASCAL WndProc( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam );
void HelpDialog( HWND hWnd );
BOOL WINAPI HelpDlgProc(HWND hDlg, UINT nMsg, WPARAM wParam, LPARAM lParam );
void CenterWindow( HWND hWnd );


//////////////////////////////////////////////////////////////////////
class CSimpleJpeg : public CImage
{
public :
    CSimpleJpeg( HWND hWnd ) : CImage( hWnd ) { m_uTimer = 0;}
    ~CSimpleJpeg() { if( m_uTimer ) KillTimer(m_hWnd, m_uTimer); }
    void MoveWindow();
    void CreateTimer( int nSec) { m_uTimer = SetTimer( m_hWnd, 111, nSec * 1000, NULL ); }

    BOOL fCloseWhenLastImage;
private :
    UINT m_uTimer;
};





//////////////////////////////////////////////////////////////////////
void CSimpleJpeg::MoveWindow()
    {
    static int fFirst = TRUE;
    int x, y, xMax, yMax;

    // Init du generateur
    if( fFirst )
	{
	srand( (unsigned)time( NULL ) );
	fFirst = FALSE;
	}
    
    // Calcul de x
    xMax = GetSystemMetrics(SM_CXSCREEN);
    x = xMax * rand() / RAND_MAX;

    if( x + (int)m_width > xMax )
	x -= m_width;
        
    // Calcul de y	
    yMax = GetSystemMetrics(SM_CYSCREEN);

    y = yMax * rand() / RAND_MAX;

    if( y + (int)m_height > yMax )
	y -= m_height;

    // On deplace la fenetre
    ::MoveWindow( m_hWnd, x, y, m_width, m_height, TRUE );
    }




//////////////////////////////////////////////////////////////////////
int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, 
				LPSTR lpszCmdParam, int nCmdShow )

    {
    HWND hWnd;
    MSG	msg;
    WNDCLASSEX wndclass;

    // Gestion des parametres passes a la fonction
    if( lpszCmdParam )
	while( *lpszCmdParam == ' ' ) lpszCmdParam ++;
    if( lpszCmdParam != NULL && lpszCmdParam[0] )
	{
	/*if( memicmp(lpszCmdParam, "-reinit", 7) == 0 )
	    {
	    RemoveAllFilesFromModule(char * pszExeName);
	    }
	else*/
	    {
	    HelpDialog( NULL );
	    }
	return 0;
	}


    InitCommonControls();

    // Enregistrement de la classe
    wndclass.cbSize = sizeof(WNDCLASSEX);
    wndclass.style = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
    wndclass.lpfnWndProc = WndProc;
    wndclass.cbClsExtra = 0;
    wndclass.cbWndExtra = 0;
    wndclass.hInstance = GetModuleHandle(NULL);
    wndclass.hIcon = LoadIcon( NULL, MAKEINTRESOURCE(IDI_ICON1) );
    wndclass.hIconSm = NULL;
    wndclass.hCursor = LoadCursor (NULL, IDC_ARROW);
    wndclass.hbrBackground = CreateSolidBrush (GetSysColor (COLOR_MENU));
    wndclass.lpszMenuName = NULL;
    wndclass.lpszClassName = "OPENWINCLASS";

    if (!RegisterClassEx (&wndclass))
	{
	MessageBox (NULL, "RegisterClassEx() failed!", "Error", MB_OK);
	return (1);
	}


    // Creation de la fenetre
    hWnd = CreateWindow( 
			"OPENWINCLASS",
			"Be careful ! Your boss 's coming ...",
			//WS_OVERLAPPEDWINDOW,
			WS_BORDER | WS_CAPTION | WS_SYSMENU,
			0,
			0,
			400,
			400,
			NULL,
			NULL,
			hInstance,
			NULL );

    // La fenetre est 
    ShowWindow( hWnd, SW_SHOW );
    UpdateWindow( hWnd );

    // Boucle des messages
    while( GetMessage( &msg, NULL, 0, 0 ) )
	{
	TranslateMessage( &msg );
	DispatchMessage( &msg );
	}

    return msg.wParam;
    }


//////////////////////////////////////////////////////////////////////
long FAR PASCAL WndProc( HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam )
    {
    CSimpleJpeg * pCtrl;
    static int s_TimeSecClose;
    static BOOL s_fExitOnClose;
    
    switch( Msg )
	{
	case WM_CREATE :
	    {
	    char szImgFile[MAX_PATH];
	    BOOL fType;
	    char szWavFile[MAX_PATH];
	    BOOL fExitOnClose;
	    char szTitle[200];
	    int TimeSecClose;	    
	    BOOL fCloseWhenLastImage;
	    BOOL fWallPaper;

#if 0
	    // On essaie de charge l'image
	    if( CreateJpgAndWavFileInTempDir( szImgFile, &fType, 
			szWavFile, &fExitOnClose, szTitle, &TimeSecClose, 
			&fCloseWhenLastImage, &fWallPaper ) == 2 )
		{
		HelpDialog( NULL );
		exit(0);
		}
#else
	    // Pour la mise au point 
	    szWavFile[0] = 0;
	    szTitle[0] = 0;
	    TimeSecClose = 0;
	    fWallPaper = 0;
	    fExitOnClose = 1;
	    fCloseWhenLastImage =  0;
	    fType = TYPE_IMG_PNG;
	    strcpy( szImgFile, "L:\\iis3root\\tiscali\\prog\\win32\\gdi\\openwin\\Debug\\01.png" );
#endif

	    // On charge le jpeg
	    pCtrl = new CSimpleJpeg( hWnd );
	    if( fType == TYPE_IMG_JPG )
		pCtrl->LoadJPG( szImgFile );
	    else if( fType == TYPE_IMG_BMP )
		pCtrl->LoadBMP( szImgFile );
	    else if( fType == TYPE_IMG_PNG )
		pCtrl->LoadPNG( szImgFile );
	    pCtrl->MoveWindow();
	    SetWindowLong( hWnd, GWL_USERDATA, (long)pCtrl );

	    // Si Wav, on le joue
	    if( szWavFile[0] )
		PlaySound( szWavFile, NULL, SND_FILENAME );

	    // Si titre, on le met
	    if( szTitle[0] )
		SetWindowText( hWnd, szTitle );

	    // Gestion du timer
	    if( TimeSecClose || s_TimeSecClose)
		{
		s_TimeSecClose = ( s_TimeSecClose == 0 ? TimeSecClose : s_TimeSecClose );
		pCtrl->CreateTimer( s_TimeSecClose );
		}

	    // mise en papier peint
	    if( fWallPaper )
		{
		char szFile[] = "c:\\~dfg.tmp";
		pCtrl->SaveBMP24( szFile );
		SystemParametersInfo( SPI_SETDESKWALLPAPER, 0, (PVOID)szFile,  
				SPIF_UPDATEINIFILE | SPIF_SENDWININICHANGE );
		}


	    // Fermeture de la fenetre en sortie
	    if( fExitOnClose || s_fExitOnClose )
		s_fExitOnClose = TRUE;

	    // Fermeture si derniere image
	    if( fCloseWhenLastImage )		
		SendMessage( hWnd, WM_DESTROY, 0, 0 );
		
	    return 0;
	    }

	case WM_TIMER:
	    {
	    SendMessage( hWnd, WM_SYSCOMMAND, SC_CLOSE, 0 );
	    return 0;
	    }

	case WM_PAINT:
	    {
	    PAINTSTRUCT ps;
	    HDC hDC;

	    hDC = BeginPaint( hWnd, &ps );
	    pCtrl = (CSimpleJpeg *)GetWindowLong( hWnd, GWL_USERDATA );
	    if( pCtrl )
		pCtrl->DrawBMP( hDC );		
	    EndPaint( hWnd, &ps );
	    return 0L;
	    }

	
	case WM_COMMAND :
	case WM_SYSCOMMAND:
	    {
	    switch(wParam )
		{
		case SC_CLOSE:
		    {
		    // Creation de la fenetre
		    HWND hOtherWnd = CreateWindow( 
			"OPENWINCLASS",
			"Be careful ! Your boss 's coming ...",
			WS_BORDER | WS_CAPTION | WS_SYSMENU,
			0,
			0,
			400,
			400,
			NULL,
			NULL,
			GetModuleHandle(NULL),
			NULL );
		    ShowWindow( hOtherWnd, TRUE );
		    
		    // On simule la fermeture en cachant cette fenetre
		    if( s_fExitOnClose )
			ShowWindow( hWnd, FALSE );
		    return 0;
		    }
		case SC_MAXIMIZE:
		case SC_MINIMIZE:
		    return 0;
		}
  	    break;
	    }

	case WM_DESTROY :
	    {
	    pCtrl = (CSimpleJpeg *)GetWindowLong( hWnd, GWL_USERDATA );
	    if( pCtrl )
		delete pCtrl;
	    PostQuitMessage( 0 );
	    return 0L;
	    }

	}

    return DefWindowProc( hWnd, Msg, wParam, lParam );
    }


//////////////////////////////////////////////////////////////////////
void HelpDialog( HWND hWnd )
    {
    static BOOL s_fDejaLance = FALSE;
    DLGPROC pfnDlgProc = MakeProcInstance((DLGPROC)HelpDlgProc, GetModuleHandle(NULL) );
    if( ! s_fDejaLance )
	{
	s_fDejaLance = TRUE;
	DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_HELP),hWnd,pfnDlgProc);
	s_fDejaLance = FALSE;
	}
    }

//////////////////////////////////////////////////////////////////////
BOOL WINAPI HelpDlgProc(HWND hDlg, UINT nMsg, WPARAM wParam, LPARAM lParam )
    {
    static CHyperLink * p1;
    char szExeFile[MAX_PATH];
    char szImgFile[MAX_PATH];
    char szWavFile[MAX_PATH];
    BOOL fParamEnable, fCloseWhenLastImage, fExitOnClose, fWallPaper;
    char szTitle[200];
    char szTimeSecClose[20];
    int TimeSecClose;

    switch (nMsg)
	{
    	case WM_INITDIALOG:
	    {
	    CenterWindow( hDlg );

	    // les liens
	    p1 = CreateLinkCtrl( hDlg, IDC_MAIL );

	    // On rajoute le mailto:
	    p1->SetURL( "mailto:sylvain.marechal1@libertysurf.fr" );

	    // On regarde l'entete de l'exe
	    if( LoadExeHeader( NULL, &fParamEnable, &fExitOnClose,
		&fCloseWhenLastImage, &TimeSecClose  ) )
		{
		// Mise a jour des valeurs
		CheckDlgButton( hDlg, IDC_CLOSEATLAST, fCloseWhenLastImage ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton( hDlg, IDC_DONTMODIFY, fParamEnable ? BST_UNCHECKED : BST_CHECKED  );
		CheckDlgButton( hDlg, IDC_EXITONCLOSE, fExitOnClose ? BST_CHECKED : BST_UNCHECKED);
		sprintf( szTimeSecClose, "%d", TimeSecClose );
		SetWindowText( GetDlgItem( hDlg,IDC_SECONDES), szTimeSecClose );
		}

	    // On a pas le droit de toucher
	    if( ! fParamEnable )
		{
		EnableWindow( GetDlgItem(hDlg,IDC_SETASWALLPAPER), FALSE );
		EnableWindow( GetDlgItem(hDlg,IDC_EXITONCLOSE), FALSE );
		EnableWindow( GetDlgItem(hDlg,IDC_WINDOWTITLE), FALSE );
		EnableWindow( GetDlgItem(hDlg,IDC_DONTMODIFY), FALSE );
		EnableWindow( GetDlgItem(hDlg,IDC_SECONDES), FALSE );
		EnableWindow( GetDlgItem(hDlg,IDC_SELECTWAV), FALSE );
		EnableWindow( GetDlgItem(hDlg,IDC_WAVFILE), FALSE );
		EnableWindow( GetDlgItem(hDlg,IDC_CLOSEATLAST), FALSE );
		EnableWindow( GetDlgItem(hDlg,IDC_SELECTIMG), FALSE );
		EnableWindow( GetDlgItem(hDlg,IDC_IMGFILE), FALSE );
		EnableWindow( GetDlgItem(hDlg,IDC_SELECTEXE), FALSE );
		EnableWindow( GetDlgItem(hDlg,IDC_EXEFILE), FALSE );
		EnableWindow( GetDlgItem(hDlg,IDC_ADD), FALSE );
		}
	    break ;
	    }

	case WM_NCDESTROY:
	    {
	    // Detruit les objets quand la fenetre est detruite
	    if( p1 ) delete p1;
	    p1 = NULL;
	    return 0;
	    }


	case WM_CTLCOLORSTATIC:
	    {
	    CHyperLink * pCtrl;
		    
	    // Prise en compte de la couleur du lien
	    pCtrl = (CHyperLink *)GetWindowLong( (HWND)lParam, GWL_USERDATA );
	    if( pCtrl )
		return (long)pCtrl->CtlColor( (HDC)wParam, CTLCOLOR_STATIC);
	    break;
	    }

        case WM_COMMAND:
        case WM_SYSCOMMAND:
	    {
	    switch (wParam)
		{
		case SC_CLOSE:
		case IDOK:
		    {
		    EndDialog (hDlg, IDOK) ;
	    	    return TRUE ;
		    break ;
		    }
                case IDC_SELECTEXE:
                    {
                    OPENFILENAME ofn;

                    GetWindowText( GetDlgItem(hDlg,IDC_EXEFILE), szExeFile, sizeof(szExeFile) );
                    memset( &ofn, 0, sizeof(OPENFILENAME) );
                    ofn.lStructSize = sizeof(OPENFILENAME);     
                    ofn.hwndOwner = hDlg; 
                    ofn.lpstrFilter = "Executable files (*.exe)\0*.exe\0\0"; 
                    ofn.lpstrFile = szExeFile; 
                    ofn.nMaxFile = MAX_PATH;
                    ofn.lpstrTitle = "Select executable";     
                    ofn.Flags =  OFN_PATHMUSTEXIST;
                    if( GetOpenFileName(&ofn) )
			{
                        SetWindowText( GetDlgItem(hDlg,IDC_EXEFILE), szExeFile );
			
			// Si on charge l'exe, on met a jour l'ecran
			if( LoadExeHeader( szExeFile, &fParamEnable, 
				&fExitOnClose, &fCloseWhenLastImage, &TimeSecClose  ) )
			    {
			    CheckDlgButton( hDlg, IDC_CLOSEATLAST, fCloseWhenLastImage ? BST_CHECKED : BST_UNCHECKED);
			    CheckDlgButton( hDlg, IDC_DONTMODIFY, fParamEnable ? BST_UNCHECKED : BST_CHECKED  );
			    CheckDlgButton( hDlg, IDC_EXITONCLOSE, fExitOnClose ? BST_CHECKED : BST_UNCHECKED);
			    sprintf( szTimeSecClose, "%d", TimeSecClose );
			    SetWindowText( GetDlgItem( hDlg,IDC_SECONDES), szTimeSecClose );
			    }
			}
                    break;
                    }
                case IDC_SELECTIMG:
                    {
                    OPENFILENAME ofn;

                    GetWindowText( GetDlgItem(hDlg,IDC_IMGFILE), szImgFile, sizeof(szImgFile) );
                    memset( &ofn, 0, sizeof(OPENFILENAME) );
                    ofn.lStructSize = sizeof(OPENFILENAME);     
                    ofn.hwndOwner = hDlg; 
                    ofn.lpstrFilter = "Jpeg files (*.jpg)\0*.jpg;*.jpeg\0\0"; 
                    ofn.lpstrFile = szImgFile; 
                    ofn.nMaxFile = MAX_PATH;
                    ofn.lpstrTitle = "Select image (JPG)";     
                    ofn.Flags =  OFN_PATHMUSTEXIST;
                    if( GetOpenFileName(&ofn) )
                        SetWindowText( GetDlgItem(hDlg,IDC_IMGFILE), szImgFile );
                    break;
                    }
                case IDC_SELECTWAV:
                    {
                    OPENFILENAME ofn;

                    GetWindowText( GetDlgItem(hDlg,IDC_WAVFILE), szWavFile, sizeof(szWavFile) );
                    memset( &ofn, 0, sizeof(OPENFILENAME) );
                    ofn.lStructSize = sizeof(OPENFILENAME);     
                    ofn.hwndOwner = hDlg; 
                    ofn.lpstrFilter = "*Wav files (*.wav)\0*.wav\0\0"; 
                    ofn.lpstrFile = szWavFile; 
                    ofn.nMaxFile = MAX_PATH;
                    ofn.lpstrTitle = "Select sound (WAV)";     
                    ofn.Flags =  OFN_PATHMUSTEXIST;
                    if( GetOpenFileName(&ofn) )
                        SetWindowText( GetDlgItem(hDlg,IDC_WAVFILE), szWavFile );
                    break;
                    }
		case IDC_ADD:
		    {		    
		    // On recupere les param
		    GetWindowText( GetDlgItem( hDlg,IDC_EXEFILE), szExeFile, sizeof(szExeFile) );
		    GetWindowText( GetDlgItem( hDlg,IDC_IMGFILE), szImgFile, sizeof(szImgFile) );
		    GetWindowText( GetDlgItem( hDlg,IDC_WAVFILE), szWavFile, sizeof(szWavFile) );
		    GetWindowText( GetDlgItem( hDlg,IDC_WINDOWTITLE), szTitle, sizeof(szTitle) );
		    GetWindowText( GetDlgItem( hDlg,IDC_SECONDES), szTimeSecClose, sizeof(szTimeSecClose) );
		    fParamEnable = ! IsDlgButtonChecked( hDlg,IDC_DONTMODIFY );
		    fCloseWhenLastImage = IsDlgButtonChecked( hDlg,IDC_CLOSEATLAST );
		    TimeSecClose = atoi(szTimeSecClose);
		    fExitOnClose = IsDlgButtonChecked( hDlg,IDC_EXITONCLOSE );
		    fWallPaper = IsDlgButtonChecked( hDlg,IDC_SETASWALLPAPER );
			
		    // On met a jour l'exe
		    if( AddFileInExe( szExeFile, szImgFile, szWavFile, 
				fParamEnable, fExitOnClose, szTitle, TimeSecClose, 
				fCloseWhenLastImage, fWallPaper ) )
			{
			MessageBox( hDlg, "Image sucessfully add !", "Message", MB_ICONINFORMATION );
			SetWindowText( GetDlgItem( hDlg,IDC_IMGFILE), "" );
			SetWindowText( GetDlgItem( hDlg,IDC_WAVFILE), "" );
			SetWindowText( GetDlgItem( hDlg,IDC_WINDOWTITLE), "" );
			CheckDlgButton( hDlg, IDC_SETASWALLPAPER, BST_UNCHECKED);
			}
		    break;
		    }

			
		case IDC_MAIL:
		    {
		    HWND hwndStatic = (HWND) LOWORD(lParam); 
		    CHyperLink * pCtrl;
		    
		    // Lancement du navigateur par defaut
		    pCtrl = (CHyperLink *)GetWindowLong( hwndStatic, GWL_USERDATA );
		    if( pCtrl )
			pCtrl->OnClicked();
		    break;
		    }

		}
	    }
	}
    return FALSE ;
    }


/*-----------------------------------------------------------------------------
**	  C E N T E R W I N D O W
**-----------------------------------------------------------------------------
**	Centrer une fenetre par rapport a sa mere
**
**  Rev 03/06/1999
**---------------------------------------------------------------------------*/
void CenterWindow( HWND hWnd )
    {
    RECT rectParent, rect;
    int x, y, cx, cy;
    BOOL fRet;
    
    fRet = GetWindowRect( GetParent(hWnd), &rectParent );
    if( fRet == 0 )
        {
        // on se base sur la taille de l'ecran
        rectParent.top = 0;
        rectParent.left = 0;
        rectParent.right = GetSystemMetrics(SM_CXSCREEN);
        rectParent.bottom = GetSystemMetrics(SM_CYSCREEN);
        }

    fRet = GetWindowRect( hWnd, &rect );
    
    // Si ca marche pas, vaut mieux partir, sinon on risque de cacher la
    // fenetre
    if( fRet == 0 )
        return;

    x	= rectParent.left + ( (rectParent.right - rectParent.left)  - (rect.right - rect.left) ) / 2;
    y	= rectParent.top + ( (rectParent.bottom - rectParent.top)  - (rect.bottom - rect.top) ) / 2;
    cx	= rect.right - rect.left;
    cy	= rect.bottom - rect.top;

    MoveWindow( hWnd, x, y, cx, cy, TRUE );
    }


