// A REVOIR 
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <png.h>
#include "pngfile.h"


/*  Callback appele chaque fois qu'une ligne est lue  */
void read_row_callback(png_structp png_ptr, png_uint_32 row_number, int pass)
    {
      /* put your code here */
    }


#if 0
char * LoadPNG( char * file_name, unsigned int * pwidth, unsigned int * pheight,  )
    {
    png_structp png_ptr;
    png_infop info_ptr;
    png_infop end_info;
    char header[8]; int number = sizeof(header);
    FILE *fp;
    png_uint_32 width, height;
    int bit_depth, color_type;
    int interlace_type, compression_type, filter_type;
    char * pImage = NULL;
    int is_png;

    
    /*  Test si png  */
    fp = fopen(file_name, "rb");
    if (!fp)
	{
        return NULL;
	}
    fread(header, 1, number, fp);
    is_png = !png_sig_cmp(header, 0, number);
    if (!is_png)
	{
        fclose(fp);
        return  NULL;
	}

    
    /*  Allocation des structures  */
    png_ptr = png_create_read_struct
       (PNG_LIBPNG_VER_STRING, (png_voidp)/*user_error_ptr*/NULL,
        /*user_error_fn*/NULL, /*user_warning_fn*/NULL);
    if (!png_ptr)
	{
        fclose(fp);
        return NULL;
	}

    info_ptr = png_create_info_struct(png_ptr);
    if (!info_ptr)
	{
        png_destroy_read_struct(&png_ptr,
           (png_infopp)NULL, (png_infopp)NULL);
        fclose(fp);
        return NULL;
	}

    end_info = png_create_info_struct(png_ptr);
    if (!end_info)
	{
        png_destroy_read_struct(&png_ptr, &info_ptr,
          (png_infopp)NULL);
        fclose(fp);
        return NULL;
	}

    
    /*  Gestion des erreurs  */
    if (setjmp(png_ptr->jmpbuf))
	{
        png_destroy_read_struct(&png_ptr, &info_ptr,
           &end_info);
        fclose(fp);
        return NULL;
	}

    /*  passage du pointeur de fichier (libpng utilise fread() par defaut)  */
    png_init_io(png_ptr, fp);

    /*  Indication de ce qui a deja ete lu  */
    png_set_sig_bytes(png_ptr, number);

    /*  Indication du nom de callback utilise  (appele a chaque ligne lue)  */
    png_set_read_status_fn(png_ptr, read_row_callback);

    
    /*  pour que 0 = opaque et 255 = transparent  */
    png_set_invert_alpha(png_ptr);


    /*  Pour faire des transformations 
    png_set_read_user_transform_fn(png_ptr,
       read_transform_fn);
    le proto est
    void read_transform_fn(png_ptr ptr, row_info_ptr
       row_info, png_bytep data)*/


    /*  lecture des informations du fichier  */
    png_read_info(png_ptr, info_ptr);


    /*  Recuperation des infos  :

    width          - holds the width of the image
                     in pixels (up to 2^31).
    height         - holds the height of the image
                     in pixels (up to 2^31).
    bit_depth      - holds the bit depth of one of the
                     image channels.  (valid values are
                     1, 2, 4, 8, 16 and depend also on
                     the color_type.  See also
                     significant bits (sBIT) below).
    color_type     - describes which color/alpha channels
                         are present.
                     PNG_COLOR_TYPE_GRAY
                        (bit depths 1, 2, 4, 8, 16)
                     PNG_COLOR_TYPE_GRAY_ALPHA
                        (bit depths 8, 16)
                     PNG_COLOR_TYPE_PALETTE
                        (bit depths 1, 2, 4, 8)
                     PNG_COLOR_TYPE_RGB
                        (bit_depths 8, 16)
                     PNG_COLOR_TYPE_RGB_ALPHA
                        (bit_depths 8, 16)

                     PNG_COLOR_MASK_PALETTE
                     PNG_COLOR_MASK_COLOR
                     PNG_COLOR_MASK_ALPHA
    */
    png_get_IHDR(png_ptr, info_ptr, &width, &height,
       &bit_depth, &color_type, &interlace_type,
       &compression_type, &filter_type);

    /* The following code transforms grayscale images of less than 8 to 8 bits,
	changes paletted images to RGB, and adds a full alpha channel if there is
	transparency information in a tRNS chunk.  This is most useful on
	grayscale images with bit depths of 2 or 4 or if there is a multiple-image
	viewing application that wishes to treat all images in the same way.    */
    if (color_type == PNG_COLOR_TYPE_PALETTE && bit_depth <= 8) 
	png_set_palette_to_rgb(png_ptr);

    if (color_type == PNG_COLOR_TYPE_GRAY && bit_depth < 8) 
	png_set_gray_1_2_4_to_8(png_ptr);

    if (png_get_valid(png_ptr, info_ptr, PNG_INFO_tRNS)) 
	png_set_tRNS_to_alpha(png_ptr);

    
    /*	PNG files pack pixels of bit depths 1, 2, and 4 into bytes as small as
	they can, resulting in, for example, 8 pixels per byte for 1 bit
	files.  This code expands to 1 pixel per byte without changing the
	values of the pixels:  */
    if (bit_depth < 8)
        png_set_packing(png_ptr);

    /*	PNG files store 3-color pixels in red, green, blue order.  This code
	changes the storage of the pixels to blue, green, red: */
    if (color_type == PNG_COLOR_TYPE_RGB ||
        color_type == PNG_COLOR_TYPE_RGB_ALPHA)
        png_set_bgr(png_ptr);

    /*	PNG files store RGB pixels packed into 3 bytes. This code expands them
	into 4 bytes for windowing systems that need them in this format: */
    if (bit_depth == 8 && color_type == PNG_COLOR_TYPE_RGB) 
	png_set_filler(png_ptr,/*filler*/0, /*PNG_FILLER_BEFORE*/PNG_FILLER_AFTER);

    /*  MAJ struct  */
    //png_read_update_info(png_ptr, info_ptr);
    
    /*  Lecture de l'image en une seule passe  */
    {
    png_bytep * row_pointers; int i;
    pImage = (char *)malloc( width * 4 * height );
    if( pImage == NULL )
	{
	png_destroy_read_struct(&png_ptr, &info_ptr, &end_info);
	return NULL;
	}
    row_pointers = (char **)malloc( height * sizeof(char *) );
    if( row_pointers == NULL )
	{
	free( pImage );
	png_destroy_read_struct(&png_ptr, &info_ptr, &end_info);
	return NULL;
	}
    for( i = 0; i < (int)height; i ++ )
	row_pointers[i] = pImage + (width * 4) * i;
    png_read_image(png_ptr, row_pointers);
    free( row_pointers );
    }

    /*  Taille pour l'appelant  */
    *pwidth = width;
    *pheight = height;
    
    /*  Nettoyage  */
    png_destroy_read_struct(&png_ptr, &info_ptr, &end_info);
    fclose(fp);
    return pImage;
    }


void FrePNG( char * pImage )
   {
   if( pImage )
	free( pImage );
   }
#endif


#if 1
void CalcDestBPP( int SrcBPP,int * pDestBPP )
{
  if (*pDestBPP == 0)
  {
    if (SrcBPP <= 8)
      *pDestBPP = 8;
    else
      *pDestBPP = 32;
  }
}

//////////////////////////////////////////////////////////////////////////////////////////
#define RGBA_BLUE   0
#define RGBA_GREEN  1
#define RGBA_RED    2
#define RGBA_ALPHA  3

char * LoadPNG( char * file_name, unsigned int * pwidth, unsigned int * pheight, RGBQUAD ** ppPalette, int * pColors )
    {
    png_uint_32 width, height;
    int bit_depth, color_type, interlace_type;
    int bHasAlpha;
    png_structp png_ptr;
    png_infop info_ptr;
    char header[8]; int number = sizeof(header);
    FILE *fp;
    char * pImage = NULL;
    int is_png;
    int * pDestBPP; int DestBPP;
    png_color* ppng_color_tab=NULL;
    int   nbColor=0;

    /*  Inits  */
    *pwidth = 0;
    *pheight = 0;
    *ppPalette = NULL;
    *pColors = 0;
    
    pDestBPP = &DestBPP;
    DestBPP = 8;

    /*  Test si png  */
    fp = fopen(file_name, "rb");
    if (!fp)
	{
        return NULL;
	}
    fread(header, 1, number, fp);
    is_png = !png_sig_cmp(header, 0, number);
    if (!is_png)
	{
        fclose(fp);
        return  NULL;
	}

    
    /*  Allocation des structures  */
    png_ptr = png_create_read_struct
       (PNG_LIBPNG_VER_STRING, (png_voidp)/*user_error_ptr*/NULL,
        /*user_error_fn*/NULL, /*user_warning_fn*/NULL);
    if (!png_ptr)
	{
        fclose(fp);
        return NULL;
	}

    info_ptr = png_create_info_struct(png_ptr);
    if (!info_ptr)
	{
        png_destroy_read_struct(&png_ptr,
           (png_infopp)NULL, (png_infopp)NULL);
        fclose(fp);
        return NULL;
	}


    
    /*  Gestion des erreurs  */
    if (setjmp(png_ptr->jmpbuf))
	{
        png_destroy_read_struct(&png_ptr, &info_ptr, NULL);
        fclose(fp);
        return NULL;
	}

    /*  passage du pointeur de fichier (libpng utilise fread() par defaut)  */
    png_init_io(png_ptr, fp);

    /*  Indication de ce qui a deja ete lu  */
    png_set_sig_bytes(png_ptr, number);

    /*  Indication du nom de callback utilise  (appele a chaque ligne lue)  */
    png_set_read_status_fn(png_ptr, read_row_callback);


    /* The call to png_read_info() gives us all of the information from the
     * PNG file before the first IDAT (image data chunk).  REQUIRED
     */
    png_read_info(png_ptr, info_ptr);

    png_get_IHDR(png_ptr, info_ptr, &width, &height, &bit_depth, &color_type,
                 &interlace_type, NULL, NULL);

    switch (color_type)
    {
      case PNG_COLOR_TYPE_RGB:
        CalcDestBPP (32, pDestBPP);
        bHasAlpha = 0;
        break;
      case PNG_COLOR_TYPE_RGB_ALPHA:
        CalcDestBPP (32, pDestBPP);
        bHasAlpha = 1;
        break;
      case PNG_COLOR_TYPE_GRAY:
        if (*pDestBPP != 32)
        {
          CalcDestBPP (8, pDestBPP);
          bHasAlpha = 0;
        }
        else
        {
          CalcDestBPP (32, pDestBPP);
          png_set_gray_to_rgb (png_ptr);
          png_set_expand(png_ptr);
          bHasAlpha = 0;
        }
        break;
      case PNG_COLOR_TYPE_GRAY_ALPHA:
        CalcDestBPP (32, pDestBPP);
        png_set_gray_to_rgb(png_ptr);
        png_set_expand(png_ptr);
        bHasAlpha = 1;
        break;
      case PNG_COLOR_TYPE_PALETTE:
        if (bit_depth != 16 && *pDestBPP != 32)
          CalcDestBPP (8, pDestBPP);
        else
        { // 16-bit palette image
          png_set_expand(png_ptr);
          CalcDestBPP (32, pDestBPP);
        }
        bHasAlpha = 0;
        break;
    }

    if (*pDestBPP == 32)
    { // Make sure we use the correct byte order
#if (RGBA_BLUE + 2 == RGBA_RED)
      png_set_bgr (png_ptr);
#else
  #if (RGBA_BLUE == RGBA_RED + 2)
  #else
  #error Unsupported byte ordering!
  #endif
#endif
      if (!bHasAlpha)
#if (RGBA_ALPHA == 3)
        png_set_filler(png_ptr, 0xff, PNG_FILLER_AFTER);
#else
        png_set_filler(png_ptr, 0xff, PNG_FILLER_BEFORE);
#endif
    }

//    if (bHasAlpha)
//      // Image has alpha channel
//      pBmp->Create (width, height,
//                    *pDestBPP, TRUE);
//    else
//      // Image doesn't have alpha channel
//      pBmp->Create (width, height,
//                    *pDestBPP, FALSE);

    if (color_type == PNG_COLOR_TYPE_GRAY  && *pDestBPP != 32)
    {
      int i;
      int NumColors = 1<<(bit_depth);
      for (i=0; i<NumColors; i++)
      {
        int CurColor = (i*255)/(NumColors-1);
//        pBmp->SetPaletteEntry(i, CurColor, CurColor, CurColor, 0xFF);
      }
    }

  if (color_type == PNG_COLOR_TYPE_PALETTE && *pDestBPP != 32)
    {
      int   i;

      png_get_PLTE(png_ptr,info_ptr,&ppng_color_tab,&nbColor);

      // Mise a jour de la palette
      *pColors = 256;
      *ppPalette = (RGBQUAD *)malloc( sizeof(RGBQUAD) * nbColor);
      memset( *ppPalette, 0, sizeof(RGBQUAD) * nbColor);

      for (i=0; i< min(nbColor,256); i++)
      {
//        pBmp->SetPaletteEntry(i,
//                              (*(ppng_color_tab+i)).red,
//                              (*(ppng_color_tab+i)).green,
//                              (*(ppng_color_tab+i)).blue,
//                              0xFF);
	(*ppPalette)[i].rgbBlue = (*(ppng_color_tab+i)).blue;
	(*ppPalette)[i].rgbGreen = (*(ppng_color_tab+i)).green;
	(*ppPalette)[i].rgbRed = (*(ppng_color_tab+i)).red;
	(*ppPalette)[i].rgbReserved = 0;
      }
    }

    if (bit_depth == 16)
      png_set_strip_16(png_ptr);
    if (bit_depth < 8)
      png_set_packing(png_ptr);

//    BYTE ** pLineArray = pBmp->GetLineArray();
//    png_read_image(png_ptr, pLineArray);



    /*  Lecture de l'image en une seule passe  */
    {
    png_bytep * row_pointers; int i;
    pImage = (char *)malloc( width * height * (*pDestBPP >> 3));
    if( pImage == NULL )
	{
	png_destroy_read_struct(&png_ptr, &info_ptr, NULL);
	free( *ppPalette );
	return NULL;
	}
    row_pointers = (char **)malloc( height * sizeof(char *) );
    if( row_pointers == NULL )
	{
	free( pImage );
	free( *ppPalette );
	png_destroy_read_struct(&png_ptr, &info_ptr, NULL);
	return NULL;
	}
    for( i = 0; i < (int)height; i ++ )
	row_pointers[i] = pImage + (width * (*pDestBPP >> 3)) * i;
    png_read_image(png_ptr, row_pointers);

    free( row_pointers );
    }

    /*  Taille pour l'appelant  */
    *pwidth = width;
    *pheight = height;
    
    /* read rest of file, and get additional chunks in info_ptr - REQUIRED */
    png_read_end(png_ptr, info_ptr);

    /* clean up after the read, and free any memory allocated - REQUIRED */
    png_destroy_read_struct(&png_ptr, &info_ptr, (png_infopp)NULL);
    fclose(fp);
    return pImage;
    }
#endif